
void setSpeed(byte s){ //Ορισμός ταχύτητας με PWM
  analogWrite(5,s); //Ταχύτητα δεξιού μοτέρ
  analogWrite(6,s); //Ταχύτητα αριστερού μοτέρ
}

void rfw(){ //Δεξί μοτέρ μπροστά
  digitalWrite(3,HIGH); 
  digitalWrite(4,LOW);
}

void lfw(){ //Αριστερό μοτέρ μπροστά
  digitalWrite(7,HIGH);
  digitalWrite(8,LOW);
}

void rbw(){ //Δεξί μοτέρ πίσω
  digitalWrite(3,LOW);
  digitalWrite(4,HIGH);
}

void lbw(){ //Δεξί μοτέρ πίσω
  digitalWrite(7,LOW);
  digitalWrite(8,HIGH);
}

void rstop(){ //Σταμάτημα δεξιού μοτέρ
  digitalWrite(3,LOW);
  digitalWrite(4,LOW);
}

void lstop(){ //Σταμάτημα αριστερού μοτέρ
  digitalWrite(7,LOW);
  digitalWrite(8,LOW);
}

void fw(){ //Κίνηση μπροστά
  rfw();
  lfw();
}

void bw(){ //Κίνηση πίσω
  rbw();  
  lbw();
}

void left(){ //Στροφή αριστερά
  lbw();
  rfw();
}

void right(){ //Στροφή δεξιά
  rbw();
  lfw();
}

void stop() { //Σταμάτημα
  rstop();
  lstop(); 
}

int trig = 9; //Trigger HC-SR04
int echo = 10; //Echo HC-SR04

void setup() {
  pinMode(3,OUTPUT); //Pin 2 SN754410
  pinMode(4,OUTPUT); //Pin 7 SN754410
  pinMode(7,OUTPUT); //Pin 10 SN754410
  pinMode(8,OUTPUT); //Pin 15 SN754410
  pinMode(trig,OUTPUT);
  pinMode(echo,INPUT);
  delay(500);
}

void loop() {
  unsigned long duration; //Μεταβλητή για τη διάρκεια του παλμού
  float distance; //Μεταβλητή για την απόσταση
  
  digitalWrite(trig,LOW); //Σχηματισμός παλμού HIGH 11μs
  delayMicroseconds(2);
  digitalWrite(trig,HIGH);
  delayMicroseconds(11);
  digitalWrite(trig,LOW);
  delayMicroseconds(2);  
  
  duration = pulseIn(echo,HIGH); //Μέτρηση διάρκειας παλμού
  distance = 0.034*duration/2; //Υπολογισμός απόστασης
 if (distance < 20) { //Αν η απόσταση είναι μικρότερη από 20cm
    stop(); //Σταμάτημα
    delay(50); //Αναμονή 50ms
    left(); //Στροφή αριστερά
    delay(200); //Διάρκεια κίνησης
    stop(); //Σταμάτημα
    delay(100); //Αναμονή 50ms
  }
  else if (distance < 40) //Αν  20cm < απόσταση < 40cm
  {
    setSpeed(200); //Μείωση ταχύτητας
    fw(); //Κίνηση μπροστά
  }
  else //Αν απόσταση > 40cm
  {
    setSpeed(255); //Μέγιστη ταχύτητα
    fw(); //Κίνηση μπροστά
  }
  delay(100); //Καθηστέρηση πριν την επόμενη μέτρηση
}
