#include <LiquidCrystal_I2C.h> //Βιβλιοθήκη για LCD
//Βιβλιοθήκη για σειριακή επικοινωνία
#include <SoftwareSerial.h>
//Δήλωση αντικειμένου Software Serial
SoftwareSerial hc12srl(4,5);
//Δήλωση αντικειμένου Liquid Crystal I2C
LiquidCrystal_I2C mylcd(0x27, 16, 2);
byte cur_channel = 2; //Τρέχον κανάλι ασύρματης επικοινωνίας
String label = "Temp1 :"; //Ετικέτα εμφάνισης

void setup() {
  hc12srl.begin(9600); //Εκκίνηση επικοινωνίας με HC-12
  //Η ακίδα που συνδέεται στο Set ορίζεται ως έξοδος
  pinMode(7, OUTPUT);
  digitalWrite(7, HIGH); //Λειτουργία μετάδοσης
  delay(1000); //Χρονοκαθυστέρηση 1 sec
  mylcd.init(); //Αρχικοποίηση οθόνης
  mylcd.clear(); //Καθαρισμός οθόνης
  mylcd.backlight(); //Ενεργοποίηση οπίσθιου φωτισμού
}

void loop() {
  digitalWrite(7, LOW); //Μετάβαση σε λειτουργία AT
  delay(200); //Χρονοκαθυστέρηση 200 ms
  hc12srl.print("AT+C00"); //Ορισμός καναλιού επικοινωνίας
  hc12srl.println(cur_channel);
  //Ανάγνωση απόκρισης από το hc-12
  String response = hc12srl.readStringUntil(10);
  if (response.startsWith("OK")) //Αν έγινε ο ορισμός
  {
    //Μετάβαση σε λειτουργία μετάδοσης
    digitalWrite(7, HIGH); 
    delay(200); //Χρονοκαθυστέρηση 200 ms
    hc12srl.println("get"); //Αποστολή εντολής get
    //Υπολογισμός χρόνου λήξης αναμονής
    unsigned long stop_wait = millis() + 600;
    //Όσο δεν υπάρχουν δεδομένα και δεν έχει λήξει η αναμονή
    while (!hc12srl.available() && millis() < stop_wait);
    if (hc12srl.available()) //Αν υπάρχουν δεδομένα
    { 
      //Ανάγνωση εισερχόμενων δεδομένων
      String temp = hc12srl.readStringUntil(13);
      //Αφαίρεση του χαρακτήρα νέας γραμμής από το buffer
      hc12srl.readStringUntil(10);
      mylcd.print(label); //Εμφάνιση της ετικέτας
      mylcd.print(temp); //Εμφάνιση θερμοκρασίας
      mylcd.write(223); //Εμφάνιση συμβόλου βαθμών
      mylcd.print("C "); //Εμφάνιση του C
      delay(600); //Χρονοκαθυστέρηση 600 ms
    }
    else //Αν έληξε ο χρόνος αναμονής
    { //Μήνυμα για απουσία απόκρισης
      mylcd.print("no response     ");
    }
  }
  else //Αν δεν έγινε ο ορισμός καναλιού
  { //Εμφάνιση μηνύματος
    mylcd.print("not set         ");
    delay(800); //Χρονοκαθυστέρηση 800 ms
  }
  if (cur_channel == 2) //Αν το τρέχον κανάλι είναι το 2
  { //Μεταφορά στη δεύτερη σειρά της οθόνης
    mylcd.setCursor(0, 1); 
    label = "Temp2: "; //Αλλαγή ετικέτας σε Temp2
    cur_channel = 7; //Αλλαγή τρέχοντος καναλιού σε 7
  }
  else //Αν το τρέχον κανάλι είναι το 7
  { //Μεταφορά στην πρώτη σειρά της οθόνης
    mylcd.setCursor(0, 0);
    label = "Temp1: "; //Αλλαγή ετικέτας σε Temp1
    cur_channel = 2; //Αλλαγή τρέχοντος καναλιού σε 2
  }
}
