//Κώδικας Εφαρμογής 13: Αισθητήρας HC-SR04/Ηλεκτρονικό Ζάρι
//από το βιβλίο "Ανάπτυξη Εφαρμογών με το Arduino"
//Εκδόσεις Τζιόλα
//Π. Παπάζογλου, Σ. Λιωνής

const int Echo_Pin = 2;//Pin εξόδου αισθητήρα
const int Trigger_Pin = 3;//Pin ενεργοπ. αισθητήρα
const int roll_delay = 2000;//Καθυστέρηση ρίψης
const int LED_Pins[] = {5,7,4,6};//Pins των LED
const int dice[6][4] = {{HIGH,LOW,LOW,LOW},//1
    		        	{LOW,HIGH,LOW,LOW},//2
				{HIGH,HIGH,LOW,LOW},//3
				{LOW,HIGH,HIGH,LOW},//4
				{HIGH,HIGH,HIGH,LOW},//5
				{LOW,HIGH,HIGH,HIGH}};//6

void setup() 
{ 
 int i;

 for(i=0;i<4;i++)
 {
   pinMode(LED_Pins[i], OUTPUT);   
 } 
 pinMode(Trigger_Pin, OUTPUT);
 pinMode(Echo_Pin, INPUT);
 //Αρχικοποίηση γεννήτριας ψευδοτυχαίων αριθμών
 randomSeed(analogRead(A0));
 //Αρχικοποίηση σειριακής επικοινωνίας
 Serial.begin(9600);
}

void loop() 
{
 long duration;//Μεταβλητή για διάρκεια παλμού
 float distance; //Μεταβλητή για απόσταση
 //Παλμός εκκίνησης μέτρησης
 digitalWrite(Trigger_Pin,HIGH);
 delayMicroseconds(11);
 digitalWrite(Trigger_Pin,LOW);

 //Ανάγνωση διάρκειας επιστρεφόμενου παλμού
 duration = pulseIn(Echo_Pin, HIGH);
 distance = 0.034*duration/2;//Υπολογισμός απόστασης
 if(distance < 5)
 {//Αν η απόσταση < 5 cm ρίξε το ζάρι
   roll();  
 }
 else
  delay(200);//Αναμονή πριν την επόμενη μέτρηση
}

void roll()
{
 int i; 
 int result = random(1,7);//Τυχαίος αριθμός 1 - 6
 for(i=0;i<4;i++)//Σβήσε όλα τα LED
 { 
   digitalWrite(LED_Pins[i], LOW);
 } 
 delay(roll_delay);//Περίμενε 2 sec
 for (i=0;i<4;i++)//Εμφάνισε το αποτέλεσμα
 {            //ανάβοντας τα κατάλληλα LED
   digitalWrite(LED_Pins[i],dice[result-1][i]);
 }
 Serial.println(result);//Εμφάνιση στην κονσόλα
}

