//Κώδικας Εφαρμογής 6: Φωτεινός Σηματοδότης Αυτοκινήτων με Πεζοφάναρο
//από το βιβλίο "Ανάπτυξη Εφαρμογών με το Arduino"
//Εκδόσεις Τζιόλα
//Π. Παπάζογλου, Σ. Λιωνής

const int Red_Cars_Pin = 13;//κόκκινο οδηγών
const int Orange_Cars_Pin = 11;//πορτοκαλί οδηγών
const int Green_Cars_Pin = 9;//πράσινο οδηγών
const int Red_Ped_Pin = 6;//κόκκινο πεζών
const int Green_Ped_Pin = 4;//πράσινο πεζών

//διάρκεια φάσης 2
const unsigned long Orange_Delay = 2000;
//αναμονή μέχρι τη φάση 2
const unsigned long wait_to_ph2 = 4000;

//διάρκεια φάσης 1
volatile unsigned long Green_Delay;
//διάρκεια φάσης 3
volatile unsigned long Red_Delay; 
unsigned long start_time;//αρχή φάσης
unsigned long elapsed_time = 0;//χρόνος από αρχή

void setup() 
{ 
  pinMode(Red_Cars_Pin, OUTPUT); 
  pinMode(Orange_Cars_Pin, OUTPUT);
  pinMode(Green_Cars_Pin, OUTPUT);
  pinMode(Red_Ped_Pin, OUTPUT); 
  pinMode(Green_Ped_Pin, OUTPUT); 
  //ορισμός διακοπής για το pin του κουμπιού
  attachInterrupt(0, buttonpush, RISING);
}

void loop() 
{
  Green_Delay = 10000;//διάρκεια Φάσης 1 10 sec
  Red_Delay = 5000;// διάρκεια φάσης 3 5 sec 
  digitalWrite(Red_Ped_Pin, HIGH);//φάση 1
  digitalWrite(Green_Cars_Pin, HIGH);
  elapsed_time = 0;
  start_time = millis();//χρόνος έναρξης φάσης 1
  while(elapsed_time <= Green_Delay) 
  {//αναμονή φάσης 1
    elapsed_time = millis()-start_time;
  }        
  digitalWrite(Green_Cars_Pin,LOW);
  digitalWrite(Orange_Cars_Pin, HIGH);//φάση 2
  start_time = millis();//χρόνος έναρξης φάσης 2
  while(millis() - start_time <= Orange_Delay)
  {//αναμονή φάσης 2
  }        
  digitalWrite(Orange_Cars_Pin, LOW);
  digitalWrite(Red_Cars_Pin, HIGH); //φάση 3
  digitalWrite(Red_Ped_Pin, LOW);
  digitalWrite(Green_Ped_Pin, HIGH);
  start_time = millis();//χρόνος έναρξης φάσης 3
  while(millis() - start_time <= Red_Delay)
  {//αναμονή φάσης 3
  }        
  digitalWrite(Green_Ped_Pin, LOW);
  digitalWrite(Red_Cars_Pin, LOW);
}

void buttonpush()
{ //αν ο χρόνος μέχρι τη φάση 2 > 4 sec
  if (Green_Delay - elapsed_time > wait_to_ph2)
  {//η μετάβαση στη φάση 2 να γίνει σε 4 sec
    Green_Delay = elapsed_time + wait_to_ph2;
  }
  Red_Delay = 7000;//διάρκεια φάσης 3 7 sec
}

