//Κώδικας Εφαρμογής 9: Δημιουργία Παιχνιδιού
//από το βιβλίο "Ανάπτυξη Εφαρμογών με το Arduino"
//Εκδόσεις Τζιόλα
//Π. Παπάζογλου, Σ. Λιωνής

//Εισαγωγή βιβλιοθήκης LiquidCrystal
#include <LiquidCrystal.h>

const int Button_Pins[3] = {8,9,10};//pin κουμπιών
//Θέσεις εμφάνισης κρεμμυδιού στην οθόνη
const int lcd_pos[3] = {1,7,13};

//Δημιουργία μεταβλητής τύπου LiquidCrystal 
LiquidCrystal lcd(2,3,4,5,6,7);

void setup(){
  int i;
  //Ορισμός διαστάσεων της οθόνης
  lcd.begin(16, 2);
  for(i=0;i<3;i++)
    pinMode(Button_Pins[i], INPUT);
  //Αρχικοποίηση γεννήτριας ψευδοτυχαίων αριθμών
  randomSeed(analogRead(A0));
}

void loop(){
  int i;
  int pos; //Μεταβλητή για τη θέση του κρεμμυδιού
  //Μεταβλητή που δείχνει αν έχει πατηθεί κουμπί
  boolean button_pressed=false; 
  //Μεταβλητή για τη θέση που επιλέγει ο χρήστης
  int chosen_pos;

  lcd.print("Press any key");
  do{//Αναμονή μέχρι να πατηθεί κάποιο κουμπί
    for(i=0;i<3;i++) //Έλεγχος των κουμπιών
    {
      if(digitalRead(Button_Pins[i])==HIGH)
      {
        button_pressed = true;
      }
    }
  }
  while(!button_pressed);
  button_pressed = false;
  lcd.clear(); //Καθαρισμός οθόνης
  //Εμφάνιση θέσεων για το κρεμμύδι
  lcd.print("( )   ( )   ( ) ");
  for(i=0;i<15;i++)//Κρύψιμο του κρεμμυδιού 
  { 
    pos = random(0,3);//Τυχαίος αριθμός 0-2
    //Μετάβαση στην αντίστοιχη θέση
    lcd.setCursor(lcd_pos[pos],0);
    lcd.write('*');//Εμφάνιση κρεμμυδιού
    delay(120);
    //Μετάβαση στη θέση που βρίσκεται το κρεμμύδι
    lcd.setCursor(lcd_pos[pos],0);
    lcd.write(' ');//Εξαφάνιση κρεμμυδιού
    delay(100);
  }
  //Μετάβαση στην αρχή της δεύτερης γραμμής
  lcd.setCursor(0,1);
  lcd.print("Find the onion");//Μήνυμα προτροπής
  do{//Αναμονή μέχρι να επιλέξει ο χρήστης 
    //Αποκλειστικός έλεγχος κουμπιών
    if(digitalRead(Button_Pins[0])==HIGH)
    {
      button_pressed = true;
      chosen_pos = 0;
    }
    else if(digitalRead(Button_Pins[1])==HIGH)
    {
      button_pressed = true;
      chosen_pos = 1;
    }
    else if(digitalRead(Button_Pins[2])==HIGH)
    {
      button_pressed = true;
      chosen_pos = 2;
    }
  }
  while(!button_pressed);
  //Εμφάνιση του κρεμμυδιού
  lcd.setCursor(lcd_pos[pos],0);
  lcd.write('*');
  //μετάβαση στην αρχή της 2ης γραμμής
  lcd.setCursor(0,1); 
  if(pos==chosen_pos)//Αν βρέθηκε το κρεμμύδι
  {
    lcd.print("YOU WIN!!! :-)  ");//Μήνυμα νίκης
  }
  else
  {
    lcd.print("You Lose :-(    ");//Μήνυμα ήττας
  }
  delay(3000);
  lcd.clear();//Καθαρισμός οθόνης
}

