import processing.serial.*;
Serial myPort; 

int cx, cy;
float mlineRadius;
float meterDiameter;
float c=0; //Μέτρηση που θα εμφανιστεί  

void setup() 
{
  //Αρχικοποίηση σειριακής θύρας
  myPort = new Serial(this, "COM5", 9600);
  
  //Αρχικοποίηση παραθύρου εφαρμογής
  size(640, 360);

  //Καθορισμός διαστάσεων για εμφάνιση στο παράθυρο της εφαρμογής
  int radius = min(width, height) / 2; 
  mlineRadius = radius * 0.72;
  meterDiameter = radius * 1.8;
  
  //Υπολογισμός μέσης παραθύρου εφαρμογής
  cx = width / 2;
  cy = height / 2;
}
void draw() 
{
    String inString=myPort.readStringUntil('\n');     
  //Ανάγνωση γραμμής από θύρα
    if (inString!=null)                              
  //Αν ο buffer δεν είναι άδειος
    {
       String[] num=splitTokens(inString,".");        //Διαχωρισμός βάσει του "."
       int a=Integer.parseInt(num[0]);                
  //a=ακέραιο μέρος
       int b=Integer.parseInt(num[1].trim());         //b=κλασματικό μέρος 
                //trim=απόρριψη μη αποδεκτών
                
  //Συμβόλων στα δεξιά
       c=(float)b/100;                                
  //Δημιουργία κλασματικού μέρους
       c=a+c;                      
  //Τελική αριθμητική μορφή μέτρησης
       println(c);                 
  //Εμφάνιση τρέχουσας θερμοκρασίας στην κονσόλα
    }
  
    background(64,128,128);      
  //Χρώμα φόντου για την «ενημέρωση» του οργάνου


    //Σχεδίαση φόντου του αναλογικού οργάνου
    fill(80);
    noStroke();
    ellipse(cx, cy, meterDiameter, meterDiameter);
  
    //Μετατροπή κλίμακας (εύρους τιμών)
    float s=map((float)c,0,45,0,PI)-PI;
    //Σχεδίαση εντός της περιοχής του οργάνου
    stroke(255);

  strokeWeight(1);
  
  //Εμφάνιση τίτλου οργάνου
  fill(128,128,0); textSize(16);
  text("TEMPERATURE",cx-50,height-50);
  int d=135;
  
  //Σχεδίαση αριθμητικών ενδείξεων
  text("0",cx+(d+10)*cos(radians(180)),cy+d*sin(radians(180)));
  text("11",cx+(d+20)*cos(radians(225)),cy+d*sin(radians(225)));
  text("22.5",(cx-10)+d*cos(radians(270)),cy+d*sin(radians(270)));
  text("34",cx+(d+10)*cos(radians(315)),cy+d*sin(radians(315)));
  text("45",cx+d*cos(radians(360)),cy+d*sin(radians(360)));
    
  //Σχεδίαση βέλους μέτρησης (ευθύγραμμο τμήμα)
  line(cx, cy, cx + cos(s) * mlineRadius, cy + sin(s) * mlineRadius);

//Σχεδίαση ημικύκλιου με διακριτές κουκίδες
  strokeWeight(5);
  for (int a = 180; a < 360; a+=6) 
  {
    float angle = radians(a);
    float x = cx + cos(angle) * mlineRadius;
    float y = cy + sin(angle) * mlineRadius;
    point(x,y);  
  }
}